//<![CDATA[
var newmap;


var js_logged_in = false;




Function.prototype.method = function (name, func) {

	this.prototype[name] = func;

	return this;

};





function mapmaker () {

	this.map;

	this.icon0;

	this.html;

	this.newpoints = new Array();

	this.overlay;

	this.point;

	this.editmode = false;

	this.editnum;

	this.originalLat;

	this.originalLng;


	this.savedmap = false;


};



function init () {

	newmap = new mapmaker();

	newmap.Create();

	newmap.addSavedPoints();

	newmap.addPoints();



};



mapmaker.method('Create', function () {

	this.map = new GMap2(document.getElementById("map"), {draggableCursor: 'arrow', draggingCursor: 'arrow'});

	this.map.setCenter(new GLatLng(37.98418959179792,23.728065490722656), 10);
	this.map.addControl(new GLargeMapControl());

	this.map.addControl(new GMapTypeControl());


	this.map.setMapType(G_NORMAL_MAP);


	GEvent.bind(this.map, "click", this,this.onClick);

	this.icon0 = new GIcon();

	this.icon0.image = "http://www.google.com/mapfiles/marker.png";

	this.icon0.shadow = "http://www.google.com/mapfiles/shadow50.png";

	this.icon0.iconSize = new GSize(20, 34);

	this.icon0.shadowSize = new GSize(37, 34);

	this.icon0.iconAnchor = new GPoint(9, 34);

	this.icon0.infoWindowAnchor = new GPoint(9, 2);

	this.icon0.infoShadowAnchor = new GPoint(18, 25);

});



mapmaker.method('onClick', function(overlay, point) {

	if (this.editmode == false) {

		if(document.getElementById("lockcheck").checked == true || document.getElementById("lockcheck").value==1) {

			document.getElementById("lng").value = point.x;

			document.getElementById("lat").value = point.y;

		} else {

			if (overlay != null) return;

			if (this.map.getZoom() < 17) this.map.setCenter(point, this.map.getZoom() + 1 );

		}

	} else {

		document.getElementById("lng").value = point.x;

		document.getElementById("lat").value = point.y;

		var num = this.editnum;

		newmap.moveMarker(num);

	}

});



mapmaker.method('addSavedPoints', function() {

	
});



mapmaker.method('moveMarker', function(num) {

	this.newpoints[num][0] = document.forms.storageform.lat.value;

	this.newpoints[num][1] = document.forms.storageform.lng.value;

	if(num > -1) {

		return this.newpoints[num][4].setPoint(new GLatLng(this.newpoints[num][0],this.newpoints[num][1]));

	}

});



mapmaker.method('addPoints', function() {

	document.forms.storageform.onsubmit = function() {

		if(newmap.editmode != true) {

			if(document.forms.storageform.lat.value != "" && document.forms.storageform.lng.value != "" && document.forms.storageform.name.value != "" && document.forms.storageform.stuff.value != "") {

				return newmap.addpoint(document.forms.storageform.lat.value,document.forms.storageform.lng.value,document.forms.storageform.name.value,document.forms.storageform.stuff.value);

			} else {

				return false;

			}

		} else {

			

			var num = newmap.editnum;

			newmap.map.removeOverlay(newmap.newpoints[num][4])

			

			newmap.newpoints[num][0] = document.forms.storageform.lat.value;

			newmap.newpoints[num][1] = document.forms.storageform.lng.value;

			newmap.newpoints[num][2] = document.forms.storageform.name.value;

			newmap.newpoints[num][3] = document.forms.storageform.stuff.value;



			newmap.map.removeOverlay(newmap.newpoints[num][4]);

			var point = new GPoint(newmap.newpoints[num][1],newmap.newpoints[num][0]);

			var marker = newmap.createMarker(point,newmap.icon0,newmap.newpoints[num][3]);

			newmap.map.addOverlay(marker);

			newmap.newpoints[num][4] = marker;



			newmap.editmode = false;

			newmap.editnum = '';

			document.getElementById('controls').className = "";

			newmap.moveMarker(num);



			document.getElementById('addmarkerbut').setAttribute('value','Add Marker');

			var controlheader = document.getElementById('controlhead')

			controlheader.removeChild(controlheader.firstChild);

			var controlheadertext = document.createTextNode("Add Marker");

			controlheader.appendChild(controlheadertext);



			document.forms.storageform.lat.value = '';

			document.forms.storageform.lng.value = '';

			document.forms.storageform.name.value = '';

			document.forms.storageform.stuff.value = '';

			newmap.updatelist();



			return false;

		}

		return false;

	}

});



mapmaker.method('addpoint', function(lat,lng,name,stuff) {

	var point = new GPoint(lng,lat);

	//Add overlay to map

	var marker = newmap.createMarker(point,this.icon0,stuff);

	this.map.addOverlay(marker);

	var newpoint = new Array(lat,lng,name,stuff,marker);


	this.newpoints[this.newpoints.length] = newpoint;

	newmap.updatelist();

	document.forms.storageform.lat.value = "";

	document.forms.storageform.lng.value = "";

	document.forms.storageform.name.value = "";

	document.forms.storageform.stuff.value = "";

	return false;

});



function addLoadEvent(func) { 

	var oldonload = window.onload; 

	if (typeof window.onload != 'function'){ 

		window.onload = func

	} else { 

		window.onload = function() {

			oldonload();

			func();

		}

	}

}



addLoadEvent(init);



mapmaker.method('removeMarker', function(num) {

	if(newmap.editmode != true) {

		deleteOK = confirm('Permanently delete marker - ' + this.newpoints[num][2] + '?')

		if (deleteOK){

			this.map.removeOverlay(this.newpoints[num][4]);

			this.newpoints.splice(num,1);

			newmap.updatelist();

		}	

	}

});



mapmaker.method('updatelist', function() {

	var storelist = document.getElementById('storagelist');

	var listitems = storelist.getElementsByTagName('LI');



	//remove all li elements from the storagelist

	while(storelist.firstChild) {

		storelist.removeChild(storelist.firstChild);

	}

	

	for(var i = 0; i < this.newpoints.length; i++) {

		//Add point details to storage list

		var elem = document.createElement("li");

		var span = document.createElement("span");

		var textstring = document.createTextNode((i+1) + ".");

		span.appendChild(textstring);

		elem.appendChild(span);

	

		//create viewlink

		var viewlink = document.createElement("a"); 

		viewlink.setAttribute('href','javascript:newmap.viewMarker(' + (i) + ');');

		viewlink.className = "viewlink";

		var viewlinktext = document.createTextNode(this.newpoints[i][2] + " ");

		viewlink.appendChild(viewlinktext);

		

		//create editlink

		var editlink = document.createElement("a"); 

		editlink.setAttribute('href','javascript:newmap.editMarker(' + (i) + ');');

		editlink.className = "editlink";

		editlink.setAttribute('title','Edit Marker');

		var editlinktext = document.createTextNode("Edit");

		editlink.appendChild(editlinktext);

		

		//create removelink

		var removelink = document.createElement("a"); 

		removelink.setAttribute('href','javascript:newmap.removeMarker(' + (i) + ');');

		removelink.className = "removelink";

		removelink.setAttribute('title','Remove marker');

		var removelinktext = document.createTextNode("Remove");

		removelink.appendChild(removelinktext);

	

		elem.appendChild(viewlink);

		elem.appendChild(removelink);

		elem.appendChild(editlink);

		

		//Add it to the storage list

		storelist.appendChild(elem);

	}

});



mapmaker.method('viewMarker', function(num) {

	if(newmap.editmode != true) {

		this.map.setCenter(new GLatLng(this.newpoints[num][0],this.newpoints[num][1]),this.map.getZoom());

		var html = '<div id="popup">' + this.newpoints[num][3] + '<\/div>';

		this.newpoints[num][4].openInfoWindowHtml(html);

	}

});



mapmaker.method('editMarker', function(num) {

	if(newmap.editmode != true) {

		this.originalLat = this.newpoints[num][0];

		this.originalLng = this.newpoints[num][1];

		this.map.setCenter(new GLatLng(this.newpoints[num][0],this.newpoints[num][1]),this.map.getZoom());

		//populate form fields

		document.forms.storageform.lat.value = this.newpoints[num][0];

		document.forms.storageform.lng.value = this.newpoints[num][1];

		document.forms.storageform.name.value = this.newpoints[num][2];

		document.forms.storageform.stuff.value = this.newpoints[num][3];

		newmap.map.closeInfoWindow();

		this.editmode = true;

		this.editnum = num;

	

		document.getElementById('controls').className = "active";

		document.getElementById('addmarkerbut').setAttribute('value','Store Changes');

		var controlheader = document.getElementById('controlhead')

		controlheader.removeChild(controlheader.firstChild);

		var controlheadertext = document.createTextNode("Edit Marker");

		controlheader.appendChild(controlheadertext);

	}

});





mapmaker.method('createMarker', function(point, icon, stuff) {

	var html = '<div id="popup">' + stuff + '<\/div>';

	var marker = new GMarker(point, icon);

	GEvent.addListener(marker, "click", function() {

		marker.openInfoWindowHtml(html);

	});

	return marker;

});



mapmaker.method('filterText', function(text) {

	var apostrophe = /'/g;

	var lr = /\r\n/g;

	var ampersand = /&/g;

	text = text.replace(ampersand, "&amp;");

	text = text.replace(apostrophe, "&#39;");

	text = text.replace(lr, "<br />");

	var lr = /\r/g;

	text = text.replace(lr, "<br />"); //mac

	text = text.replace(/\r\n|\r|\n/g, '')

	return text;

});








//]]>